open Typ
open Typcontext
open Format

(* Lookup variables, Replace N-> by N-o, Replace [][] by []*)

let rec expose' f ctx  = function 
  TVar(x) -> if f 
               then let ty = (try (lookup_abbrev x ctx) with
                              Not_found -> Support.Error.err 
                              ("Unbound type variable "^x)) in 
                    expose' f ctx ty 
               else TVar(x)
| TNat -> TNat
| TArr((l,m),t1,t2) -> let t1' = expose' true ctx t1 in 
                 if banged t1' 
                   then TArr((Linear,m),t1,t2) 
                   else TArr((l,m),t1,t2)
             
let expose ctx t = expose' true ctx t
let expose_no_abbrevs ctx t = expose' false ctx t

(* ---------------------------- *)

let deep_expose ctx t =
let rec de t =     
let de_after_exposure = function 
  | TArr(a,t1,t2) -> TArr(a,de t1,de t2)
  | t -> t
in de_after_exposure (expose_no_abbrevs ctx t)
in de t


let rec leq ctx s t = 
  let s = expose ctx s in 
  let t = expose ctx t in
  match (s,t) with 
      (TNat,TNat) -> true
  | (TArr(a,s1,s2),TArr(a',t1,t2)) -> leq_asp(a',a) & 
                                      (leq ctx t1 s1) & (leq ctx s2 t2)
  | _ -> false



let rec find_concrete_supertype ctx = function 
    TVar(x) -> find_concrete_supertype ctx (lookup_abbrev x ctx)
  | t -> expose ctx t






