(*
 * Conversion and subtyping on types
 *)

(* bring a proper type former to the surface; replace A->B by
   A-oB if banged A *)

val expose : Typcontext.ctx -> Typ.t -> Typ.t

(* Same as expose, but don't lookup variables *)
val expose_no_abbrevs : Typcontext.ctx -> Typ.t -> Typ.t

(* Same as expose_no_abbrevs, but descend recursively: used for printing *) 
val deep_expose : Typcontext.ctx -> Typ.t -> Typ.t

(* Subtype testing *)
val leq : Typcontext.ctx -> Typ.t -> Typ.t -> bool

(* Strip off boxes *)
val find_concrete_supertype : Typcontext.ctx -> Typ.t -> Typ.t



