(*
 * Simple evaluator for expressions
 *)

(* An evaluation context carries a set of bindings of top-level
   names to their values *)

type sem 
val print : sem -> unit

type context 
val empty_context : context

(* Overwrites previously existing bindings *)
val bind : string -> sem -> Typ.aspect -> context -> context

(* Evaluate an expression in a given evaluation context *)
val eval : context ->  Exp.t -> sem





